package de.mdelab.mlsdm.interpreter.eclipse.searchModel;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.interpreter.MLSDMInterpreter;
import de.mdelab.mlsdm.interpreter.eclipse.MLSDMEclipseInterpreterFactory;
import de.mdelab.mlsdm.interpreter.eclipse.MLSDMEclipseMatcherFactory;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.SDMException;
import de.mdelab.sdm.interpreter.core.notifications.NotificationEmitter;
import de.mdelab.sdm.interpreter.core.patternmatcher.StoryPatternMatcher;
import de.mdelab.sdm.interpreter.core.variables.VariablesScope;

public class MLSDMEclipseSearchModelFactory implements MLSDMEclipseInterpreterFactory , MLSDMEclipseMatcherFactory{

	@Override
	public MLSDMInterpreter createInterpreter(ClassLoader classLoader) throws SDMException {
		return new MLSDMEclipseSearchModelBasedInterpreter(classLoader);
	}

	@Override
	public StoryPatternMatcher<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> createMatcher(
			StoryPattern storyPattern,
			VariablesScope<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> variablesScope,
			ClassLoader classLoader) throws SDMException {
		return new MLSDMEclipseSearchModelBasedMatcher(storyPattern, variablesScope, classLoader, new NotificationEmitter<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>());
	}

}
