package de.mdelab.mlsdm.interpreter.facade;

import java.util.Collections;
import java.util.List;
import java.util.Map;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.sdm.interpreter.core.facade.IActivityFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMActivityFacade implements IActivityFacade<Activity, ActivityNode>
{
	@Override
	public ActivityNode getInitialNode(final Activity activity)
	{
		assert activity != null;

		for (final ActivityNode n : activity.getNodes())
		{
			if (n.eClass() == MlsdmPackage.Literals.INITIAL_NODE)
			{
				return n;
			}
		}

		return null;
	}

	@Override
	public String getName(final Activity activity)
	{
		return activity.getName();
	}

	@Override
	public Map<String, Map<String, List<String>>> getExpressionImports(final Activity activity)
	{
		return Collections.emptyMap();
	}
}
