package de.mdelab.mlsdm.interpreter.facade;

import java.util.HashMap;
import java.util.Map;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.OutputParameterValue;
import de.mdelab.sdm.interpreter.core.facade.IFinalNodeFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMActivityFinalNodeFacade extends MLSDMActivityNodeFacade implements IFinalNodeFacade<ActivityNode, MLExpression>
{

	@Override
	public Map<String, MLExpression> getOutParameterExpressions(final ActivityNode finalNode)
	{
		assert finalNode != null;
		assert finalNode instanceof ActivityFinalNode;

		final ActivityFinalNode activityFinalNode = (ActivityFinalNode) finalNode;

		final Map<String, MLExpression> map = new HashMap<String, MLExpression>();

		for (final OutputParameterValue value : activityFinalNode.getOutputParameterValues())
		{
			assert value.getParameter() != null;
			assert value.getExpression() != null;

			map.put(value.getParameter().getName(), value.getExpression());
		}

		return map;
	}

}
