package de.mdelab.mlsdm.interpreter.facade;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.sdm.interpreter.core.facade.IInstanceFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMInstanceFacade implements IInstanceFacade<AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>
{

	@Override
	public void setAttributeValue(final Object sourceInstanceObject, final EStructuralFeature feature, final Object value)
	{
		assert sourceInstanceObject != null;
		assert feature != null;
		assert sourceInstanceObject instanceof EObject;

		assert feature.isChangeable();

		((EObject) sourceInstanceObject).eSet(feature, value);
	}

	@Override
	public void delete(Object p_object) {
		EcoreUtil.delete( (EObject) p_object );
	}
}
