package de.mdelab.mlsdm.interpreter.facade;

import java.util.Collection;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.facade.IStoryPatternFacade;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMStoryPatternFacade implements
		IStoryPatternFacade<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, MLExpression>
{
	@Override
	public Collection<AbstractStoryPatternObject> getStoryPatternObjects(final StoryPattern sp)
	{
		assert sp != null;

		return sp.getStoryPatternObjects();
	}

	@Override
	public String getName(final StoryPattern sp)
	{
		assert sp != null;

		return sp.getName();
	}

	@Override
	public Collection<MLExpression> getConstraints(final StoryPattern sp)
	{
		assert sp != null;

		return sp.getConstraints();
	}
}
