package de.mdelab.mlsdm.interpreter.patternMatcher.patternPartBased;

import java.util.Map;

import org.eclipse.emf.ecore.EClassifier;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.sdm.interpreter.core.SDMException;
import de.mdelab.sdm.interpreter.core.patternmatcher.patternPartBased.ECheckResult;
import de.mdelab.sdm.interpreter.core.patternmatcher.patternPartBased.EMatchType;
import de.mdelab.sdm.interpreter.core.patternmatcher.patternPartBased.MatchState;
import de.mdelab.sdm.interpreter.core.patternmatcher.patternPartBased.PatternPartBasedMatcher;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMStoryPatternObjectOnlyPatternPart extends MLSDMPatternPart<AbstractStoryPatternObject, AbstractStoryPatternLink>
{

	public MLSDMStoryPatternObjectOnlyPatternPart(
			final PatternPartBasedMatcher<?, ?, ?, ?, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, ?, MLExpression> patternMatcher,
			final AbstractStoryPatternObject storyPatternObject)
	{
		super(patternMatcher, null, new AbstractStoryPatternObject[]
		{
			storyPatternObject
		});

		assert storyPatternObject instanceof StoryPatternObject;
	}

	@Override
	protected void doCreateLink()
	{
		// Do nothing
	}

	@Override
	protected void doDestroyLink(final Map<AbstractStoryPatternObject, Object> deletedObjects)
	{
		// Do nothing
	}

	@Override
	public ECheckResult check()
	{
		return ECheckResult.OK;
	}

	@Override
	public int calculateMatchingCost()
	{
		return 0;
	}

	@Override
	public EMatchType doGetMatchType()
	{
		return EMatchType.OPTIONAL;
	}

	@Override
	public boolean match(final MatchState matchState) throws SDMException
	{
		assert this.isCreate || this.patternMatcher.isBound(this.storyPatternObjects[0]);

		return true;
	}

	@Override
	public MatchState createMatchState()
	{
		return null;
	}
}
