package de.mdelab.mlsdm.interpreter.searchModel.model;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.PatternNode;

/**
 * This is a pattern node implementation for the MLSDM meta model.
 * 
 * @author Matthias.Barkowsky
 *
 */
public class MLSDMPatternNode extends PatternNode<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>{

	public MLSDMPatternNode(int id, MLSDMSearchModel searchModel, AbstractStoryPatternObject spo) {
		super(id, searchModel, spo);
	}

	@Override
	public String toString() {
		return getSpo().getName();
	}
}
