package de.mdelab.mlsdm.interpreter.searchModel.model.action;

import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.MatchState;

/**
 * This is a match state used for matching operations that
 * only perform an explicit check. It is important that the
 * check is only performed once to avoid finding duplicate
 * matches.
 * 
 * @author Matthias.Barkowsky
 *
 */
public class MLSDMCheckOnceMatchState extends MatchState{

	/*
	 * Whether the check has already been performed.
	 */
	private boolean alreadyChecked = false;
	
	/**
	 * Check if the check has already been performed. If it
	 * has not, mark the check as performed.
	 * 
	 * @return	True if the check has not been performed
	 * 			previously.
	 */
	public boolean check() {
		if(alreadyChecked) {
			return false;
		}
		else {
			alreadyChecked = true;
			return true;
		}
	}
}
