package de.mdelab.mlsdm.interpreter.searchModel.model.action;

import java.util.Collection;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.MLSDMSearchModelBuilder;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.PatternNode;

/**
 * This is a search model builder for creating search models
 * for a pattern of a negative application condition. It has
 * knowledge of all nodes in the parent pattern which are
 * connected to the nodes in the negative pattern.
 * 
 * @author Matthias.Barkowsky
 *
 */
public class MLSDMNACSearchModelBuilder extends MLSDMSearchModelBuilder {
	
	/*
	 * Collection of pattern nodes of the parent pattern which
	 * are connected to nodes of the negative pattern.
	 */
	protected Collection<PatternNode<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>> outsideNodes;
	
}
