package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.expressions;

import java.util.Collection;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.expressions.ExpressionAnalyzer;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.expressions.ExpressionAnalyzerManager;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.expressions.FeatureAccess;
import de.mdelab.sdm.interpreter.core.variables.Variable;

public abstract class MLSDMExpressionAnalyzer extends ExpressionAnalyzer<EClassifier, EStructuralFeature, MLExpression>{

	public MLSDMExpressionAnalyzer(
			ExpressionAnalyzerManager<EClassifier, EStructuralFeature, MLExpression> analyzerManager) {
		super(analyzerManager);
	}


	protected EStructuralFeature getVariableFeature(String name, String featureName) {
		Variable<EClassifier> variable = variablesScope.getVariable(name);
		for(EStructuralFeature feature:((EClass) variable.getClassifier()).getEAllStructuralFeatures()) {
			if(feature.getName().equals(featureName)) {
				return feature;
			}
		}
		return null;
	}
	
	@Override
	public Collection<FeatureAccess<EStructuralFeature>> getFeatureAccesses(MLExpression expression) {
		return getFeatureAccesses(expression, EcorePackage.Literals.EOBJECT);
	}

}
