package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.strategy.grgen;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.MatchingAction;

public class GRGENPlanGraphEdge {
	
	public MatchingAction<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> action;
	public double cost;
	public GRGENPlanGraphNode source;
	public GRGENPlanGraphNode target;
	
	public GRGENPlanGraphEdge(GRGENPlanGraphNode source, GRGENPlanGraphNode target, double cost) {
		this.source = source;
		this.source.out.add(this);
		
		this.target = target;
		this.target.in.add(this);
		
		this.cost = cost;
	}
	
	@Override
	public String toString() {
		return "(" + source.toString() + "->" + target.toString() + ")";
	}
}
