package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.strategy.heap;

/**
 * This is an entry in a heap data structure. It is a tuple
 * of an integer key and a value of arbitrary type.
 * 
 * @author Matthias.Barkowsky
 *
 * @param <T>
 */
public class MLSDMHeapEntry<T> {

	/*
	 * Key of the entry.
	 */
	public double key;
	
	/*
	 * Value of the entry.
	 */
	public T value;
	
	public MLSDMHeapEntry(int key, T value) {
		this.key = key;
		this.value = value;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return "HeapEntry(" + key + "->" + value + ")";
	}
	
}
