package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.strategy.heap;

import java.util.ArrayList;
import java.util.List;

/**
 * This is a heap operation composing several primitive changes
 * to a heap data structure into a single transaction.
 * 
 * @author Matthias.Barkowsky
 *
 * @param <T>
 */
public class MLSDMHeapOperation<T> {

	/*
	 * Indices of the first element of each primitive swap.
	 */
	public List<Integer> swap1 = new ArrayList<Integer>();
	
	/*
	 * Indices of the second element of each primitive swap.
	 */
	public List<Integer> swap2 = new ArrayList<Integer>();
	
	/*
	 * List of keys changed as part of the operation.
	 */
	public List<MLSDMHeapEntry<T>> keyChanges = new ArrayList<MLSDMHeapEntry<T>>();
	
	/*
	 * List of old keys of the elements whose key was changed.
	 */
	public List<Double> oldKeys = new ArrayList<Double>();
	
	/*
	 * Change in size of the heap.
	 */
	public int sizeChange = 0;
	
}
